#!/bin/bash
#checkpoints=($(seq 1000000 100 1001000))
checkpoints=( 0200 0300 0400 0500 0600 0700 0800 0900 1000   0100 0400 0500 0600 0700 0800 0900 01000 0000 0100 0200 0300 0400 0500 )
echo $checkpoints

experiments=(

experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train
experiment-common-2000-train


experiment-common-all-train


experiment-common-concrete-val
experiment-common-concrete-val
experiment-common-concrete-val
experiment-common-concrete-val
experiment-common-concrete-val
experiment-common-concrete-val
experiment-common-concrete-val


experiment-concrete-2000-train
experiment-concrete-2000-train
experiment-concrete-2000-train
experiment-concrete-2000-train
experiment-concrete-2000-train
experiment-concrete-2000-train

    )
models=(

3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns


3B2000_most_common_nouns


3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns
3B2000_most_common_nouns


3B2000_most_concrete_nouns
3B2000_most_concrete_nouns
3B2000_most_concrete_nouns
3B2000_most_concrete_nouns
3B2000_most_concrete_nouns
3B2000_most_concrete_nouns

    )
#checkpoints={1000000 100 1002500}
#experiments=( 7 7_ 7_0 7_1)
#models=( 3Blr0.03batch1 3Blr0.003batch1 3Blr0.3batch1 3Blr3.0batch1 )
n_models=${#models[@]}
n_checkpoints=${#checkpoints[@]}
n_experiments=${#experiments[@]}
gpus=($(seq 3 15))
n_gpus=${#gpus[@]}
n_data_dirs=${#data_names[@]}


gpu_iter=0
for ((iter1=0;iter<$n_checkpoints;iter++))
do
    gpu=${gpus[$gpu_iter]}
    experiment=${experiments[$iter]}
    checkpoint=${checkpoints[$iter]}
    model=${models[$iter]}

    echo experiment $experiment \
            gpu $gpu \
            checkpoint 100$checkpoint \
            which uses model $model
    CUDA_VISIBLE_DEVICES=$gpu python3 setup_t5_and_predict.py \
        --ckpt 100$checkpoint\
        --gpu_id 0\
        --experiment $experiment \
        --model_dir /atr/models-t5/$model &
    gpu_iter=$((($gpu_iter+1) % $n_gpus))

    if [ $gpu -eq ${gpus[-1]} ]
    then
        echo waiting at \
            gpu $gpu 
        wait
    fi
    echo " "
done


#for ((iter1=0;iter1<$n_models; iter1++))
#do
#    #For when n_models == n_experiments
#    gpu_iter=0
#    model=${models[$iter1]}
#    #For when there is just one model
#    #model=${models[0]}
#    for ((iter2=0;iter2<$n_data_dirs; iter2++))
#    do
#
#
#        start_time="$(date -u +%s)"
#
#        experiment=experiment-${model_names[$iter1]}-${data_names[$iter2]}
#        #Skip bc already done
#        if [ $experiment = experiment-2000-2000-train ] ||
#           [ $experiment = experiment-2000-all-train ] ||
#           [ $experiment = experiment-all-2000-train ] ||
#           [ $experiment = experiment-all-all-train ]
#                   then
#                       continue
#        fi
#
#        echo -e "\nRUNNING EXPERIMENT $experiment MODEL $model\n"
#
#        for ((iter3=0;iter3<$n_checkpoints; iter3++))
#        do
#            checkpoint=${checkpoints[$iter3]}
#            #gpu_id=$((($iter1 * $n_data_dirs * $n_checkpoints + $iter2 * $n_checkpoints + $iter3) % $n_gpus))
#            gpu=${gpus[$gpu_iter]}
#
#            #Run training script
#            echo running setup and predict on \
#                    gpu $gpu \
#                    checkpoint $checkpoint 
#            CUDA_VISIBLE_DEVICES=$gpu python3 setup_t5_and_predict.py \
#                --ckpt $checkpoint\
#                --gpu_id $gpu\
#                --experiment $experiment \
#                --model_dir /atr/models-t5/$model &
#            gpu_iter=$((($gpu_iter+1) % $n_gpus))
#
#            if [ $gpu -eq ${gpus[-1]} ]
#            then
#                echo waiting at \
#                    gpu $gpu 
#                wait
#            fi
#
#        done
#        end_time="$(date -u +%s)"
#
#        elapsed="$(($end_time-$start_time))"
#        echo "Total of $elapsed seconds elapsed for $experiment"
#        #echo $gpu $experiment $checkpoint /nlrl/models-t5/$model
#
#    done
#done



#Experiment 1

#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1000000 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1000250 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1000500 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1000750 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1001000 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt  1001250 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt  1001500 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1001750 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt 1002000 --gpu_id  0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt 1002250 --gpu_id  0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt 1002500 --gpu_id  0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1002750 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt  1003000 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt  1003250 --gpu_id 0 --experiment 'experiment1' &
#
#wait
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1003500 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1003750 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1004000 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1004250 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1004500 --gpu_id 0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt 1004750 --gpu_id  0 --experiment 'experiment1' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt 1005000 --gpu_id  0 --experiment 'experiment1' &
#                     
##Experiment2
#
#CUDA_VISIBLE_DEVICES=9   python3 setup_t5_and_predict.py --ckpt  1000000 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=10  python3 setup_t5_and_predict.py --ckpt  1000250 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=11  python3 setup_t5_and_predict.py --ckpt  1000500 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=12  python3 setup_t5_and_predict.py --ckpt  1000750 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=13  python3 setup_t5_and_predict.py --ckpt  1001000 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=14  python3 setup_t5_and_predict.py --ckpt  1001250 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt  1001500 --gpu_id 0 --experiment 'experiment2' &
#
#wait
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1001750 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt 1002000 --gpu_id  0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt 1002250 --gpu_id  0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt 1002500 --gpu_id  0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1002750 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt  1003000 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt  1003250 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1003500 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt  1003750 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt  1004000 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt  1004250 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1004500 --gpu_id 0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt 1004750 --gpu_id  0 --experiment 'experiment2' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt 1005000 --gpu_id  0 --experiment 'experiment2' &
#
#wait
#
##Experiment 4
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1000000 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1000250 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1000500 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1000750 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1001000 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt  1001250 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt  1001500 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1001750 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt 1002000 --gpu_id  0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt 1002250 --gpu_id  0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt 1002500 --gpu_id  0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1002750 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt  1003000 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt  1003250 --gpu_id 0 --experiment 'experiment4' &
#
#wait
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1003500 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1003750 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1004000 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1004250 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1004500 --gpu_id 0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt 1004750 --gpu_id  0 --experiment 'experiment4' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt 1005000 --gpu_id  0 --experiment 'experiment4' &
#
##Experiment 5
#                     
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1000000 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt  1000250 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt  1000500 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt  1000750 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1001000 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt  1001250 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt  1001500 --gpu_id 0 --experiment 'experiment5' &
#
#wait
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1001750 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt 1002000 --gpu_id  0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt 1002250 --gpu_id  0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt 1002500 --gpu_id  0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1002750 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt  1003000 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt  1003250 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1003500 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt  1003750 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt  1004000 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt  1004250 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1004500 --gpu_id 0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt 1004750 --gpu_id  0 --experiment 'experiment5' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt 1005000 --gpu_id  0 --experiment 'experiment5' &
#
#wait
#
##Experiment 6
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1000000 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1000250 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1000500 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1000750 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1001000 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt  1001250 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt  1001500 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=9  python3 setup_t5_and_predict.py --ckpt  1001750 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=10 python3 setup_t5_and_predict.py --ckpt 1002000 --gpu_id  0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=11 python3 setup_t5_and_predict.py --ckpt 1002250 --gpu_id  0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=12 python3 setup_t5_and_predict.py --ckpt 1002500 --gpu_id  0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=13 python3 setup_t5_and_predict.py --ckpt  1002750 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=14 python3 setup_t5_and_predict.py --ckpt  1003000 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=15 python3 setup_t5_and_predict.py --ckpt  1003250 --gpu_id 0 --experiment 'experiment6' &
#
#wait
#
#CUDA_VISIBLE_DEVICES=2  python3 setup_t5_and_predict.py --ckpt  1003500 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=3  python3 setup_t5_and_predict.py --ckpt  1003750 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=4  python3 setup_t5_and_predict.py --ckpt  1004000 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=5  python3 setup_t5_and_predict.py --ckpt  1004250 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=6  python3 setup_t5_and_predict.py --ckpt  1004500 --gpu_id 0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=7  python3 setup_t5_and_predict.py --ckpt 1004750 --gpu_id  0 --experiment 'experiment6' &
#CUDA_VISIBLE_DEVICES=8  python3 setup_t5_and_predict.py --ckpt 1005000 --gpu_id  0 --experiment 'experiment6' &
